#!/usr/local/bin/perl

require "./setup.cgi";

$cname = $ENV{'SCRIPT_NAME'};
$cookies = $ENV{'HTTP_COOKIE'};

@pairs = split(/;/,$cookies);
foreach $pair (@pairs) {

	($key,$val) = split(/=/,$pair,2);
	$key =~ s/ //g;

	if ($key eq $cname) {

		@pairs = split(/,/,$val);
		foreach $pair (@pairs) {

			($key,$val) = split(/:/,$pair,2);
			$COOKIE{$key} = $val;
		}
		last;
	}
}

&ReadParse;

while (($key,$val) = each %in) {

	if ($key eq '') { next; }
	if ($key eq 'goods_view') { next; }

	&jcode'h2z_sjis(*val); # pJiSp(SJIS)ϊ
	&jcode'convert(*val,'sjis'); # SJISϊ

	$val =~ s/\t//g;
	$val =~ s/\r\n/\r/g;
	$val =~ s/\n/\r/g;

	$val =~ s/&/&amp;/g;
	$val =~ s/"/&quot;/g;
	$val =~ s/</&lt;/g;
	$val =~ s/>/&gt;/g;

	if ($key eq ";attc;") { $attc = 1; }
	elsif ($key eq ";remove;") { $remove = 1; }
	elsif ($key eq ";no_attc;") { $no_attc = 1; }
	else { $in{$key} = $val; }
}

if ($in{'number'} =~ /^(\d+)(\d)$/) { $number = $1; $ext = $2; $directory = "$number\.$ext"; }
else { &error("G["); }

if ($in{'action'} eq "redirect") {

	$URL = $base_url . "tender.cgi?number=$in{'number'}&p=$in{'p'}";
	print "Location: $URL\n\n";
	exit;
}

if (!-e "$base_dir$directory\/") {

	if (-e "$base_dir$number\.0\/") { $ext = 0; &error("̏oi͓D؂ɂȂ܂","<a href=\"tender.cgi?number=$number$ext&p=$in{'p'}\">D</a>"); }
	if (-e "$base_dir$number\.1\/") { $ext = 1; &error("̏oi͓Dł","<a href=\"tender.cgi?number=$number$ext&p=$in{'p'}\">Dʂ</a>"); }
	&error("$number Not Found");
}

if (-e "$base_dir$number\.$ext\/tender.$data_ext") {

	if (!open(DATA,"$base_dir$directory\/tender.$data_ext")) { &error("G[(018)"); }
	@TEND = <DATA>;
	close(DATA);

	@TEND = reverse @TEND;
}
else { $none = 1; }

&GetData("$number\.$ext");

($limit,$remain) = &remain($number);

#DI
if ($remain <= 0 && $ext == 1) {

	if (!rename("$base_dir$directory","$base_dir$number\.0")) { &error("VXeG[(019)","̏oi͓D؂ɂȂ܂ADł܂ł.","$numberG[ł邱ƂǗ҂ɂA."); }
	$ext = 0;

	if (!-e "$base_dir$number\.0\/stop.$data_ext") {

		if (!open(END,"> $base_dir$number\.0\/stop.$data_ext")) { &error("VXeG[(020)","DIɎs܂."); }
		if (@TEND) { print END $TEND[0]; $type = 1; }
		else { $type = 0; }
		close(END);

		&end_info($number,$GOODS{$directory}{'handle'},$GOODS{$directory}{'email'},$GOODS{$directory}{'goods_name'},$GOODS{$directory}{'passwd'},$type);

		if (@TEND) {

			($number2_c,$tend_c,$handle_c,$email_c,$tel_c,$fax_c,$date_c,$host_c) = &DecodeCSV($TEND[0]);
			&end_info2($number,$number2_c,$handle_c,$email_c,$GOODS{$directory}{'goods_name'},$GOODS{$directory}{'remarks'});
		}
	}

	if ($in{'action'} eq 'faq') { $directory = "$number\.0"; &faq; }

	&error("̏oi͓D؂ɂȂ܂","<a href=\"tender.cgi?number=$number$ext&p=$in{'p'}\">D</a>");
}

if (-e "$base_dir$directory\/stop.$data_ext") {

	if ($ext == 1) { &error("G[","̏oi͓DłȂԂɂȂĂ܂(021)"); }
	if (@TEND) { $limit_view = "DI (D҂)"; }
	else { $limit_view = "DI (DȂ)"; }

	$remain = 0;
}
elsif ($remain > 0 && $ext == 0) { $limit_view = "ǗI"; $remain = 0; }
elsif ($remain < 0) { $limit_view = "Ԉُ"; $remain = 0; }
else { $limit_view = " $limit"; }

$PASSWD = 0;
if ($admin_passwd ne "" && $in{'p'} eq $admin_passwd) { $PASSWD = $SU = 1; }
elsif ($GOODS{$directory}{'passwd'} ne "") {

	if ($in{'p'} eq $GOODS{$directory}{'passwd'}) {

		$PASSWD = 1;

		if ($remain <= 0 && open(DATA,">> $base_dir$directory\/log.$data_ext")) {

			print DATA "$date_now\t$HOST\n";
			close(DATA);
			chmod(0666,"$base_dir$directory\/log.$data_ext");
		}
	}
	elsif ($in{'p'} ne "" && $in{'p'} ne $GOODS{$directory}{'passwd'}) { &error("F؃G[","pX[hv܂ł."); }
}

if ($in{'action'} eq 'faq') { &faq; }

$min_fee = $tend_fee = $GOODS{$directory}{'min_fee'};
1 while $min_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;

if ($GOODS{$directory}{'max_fee'} != 0) {

	$max_fee = $max_fee2 = $GOODS{$directory}{'max_fee'};
	1 while $max_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;
	$max_fee .= " ~";
}

if ($in{'action'} eq 'regist') {

	if ($remain < 0) { $ext = 0; &error("D؂ɂȂĂ܂","<a href=\"tender.cgi?number=$number$ext&p=$in{'p'}\">D</a>"); }
	&regist;
}

if ($in{'select'} eq 'delete') { &delete; exit; }
elsif ($in{'select'} eq 'repost') { &repost; exit; }

&html;

sub html {

if (!open(FILE,"$kitei")) { &error('G[(022)',"Kt@Cǂݏo܂."); }
@KITEI = <FILE>;
close(FILE);

$VALUE = $GOODS{$directory}{'goods_remarks'};
$VALUE =~ s/\r/<br>\r/g;
$VALUE =~ s/ /&nbsp;/g;
$VALUE =~ s/&quot;/"/g;
$VALUE =~ s/(https?|ftp|gopher|telnet|whois|news)\:([\w|\:\!\#\$\%\=\&\-\^\`\\\|\@\~\[\{\]\}\;\+\*\,\.\?\/]+)/<a href=\"$1\:$2\" target=\"_blank\">$1\:$2<\/a>/ig;

$goods_remarks = $in{'goods_remarks'};
$in{'goods_remarks'} =~ s/\r/<br>\r/g;

if ($max_fee ne "") { $max_fee_bgcolor = "#ffffaa"; }
else { $max_fee_bgcolor = "#ffffff"; }

#oiԍtZoivZ(Z)
$start_check = $number - ($GOODS{$directory}{'time'} * 86400);
($sec3,$min3,$hour3,$mday3,$mon3,$year3,$wday3,$yday3,$isdst3) = localtime($start_check);
$start_date = sprintf("%01d/%01d(%s) %02d:%02d:%02d",$mon3 +1,$mday3,$wday_array[$wday3],$hour3,$min3,$sec3);

$plus_fee = $plus_fee2 = &plus_fee($GOODS{$directory}{'min_fee'});
1 while $plus_fee =~ s/(.*\d)(\d\d\d)/$1,$2/g;
if ($plus_fee) { $plus_fee .= " ~"; }

print "Content-type: text/html\n\n";
print <<"EOF";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<HTML>
<HEAD>
<TITLE>$title_bar</TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
<SCRIPT language="JavaScript">
<!--
function message()
{
	f = confirm("s܂. 낵łH");
	return f
}
//-->
</SCRIPT>
</HEAD>
$body
<div align=right>̏ $date_now ݂̂̂ł</div>

<table width=100%>
<tr>
<td bgcolor=#ffe566 colspan=2><font size=+2><b>$GOODS{$directory}{'goods_name'}</b></font></td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>oiԍ</b></font></td>
<td bgcolor=#ffffff>$number</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>oi</b></font></td>
<td bgcolor=#ffffff>$GOODS{$directory}{'handle'}</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>ŒᗎDi</b></font></td>
<td bgcolor=#ffffff>$min_fee ~</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>DP</b></font></td>
<td bgcolor=#ffffff>$plus_fee</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>]Di</b></font></td>
<td bgcolor=$max_fee_bgcolor>$max_fee</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>Jn</b></font></td>
<td bgcolor=#ffffff>$GOODS{$directory}{'start'} <!-- $number = $start_date --></td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>D</b></font></td>
<td bgcolor=#ffffff>$GOODS{$directory}{'time'}</td>
</tr>
<tr>
<td bgcolor=#ffaaaa><b>c莞</b></font></td>
<td bgcolor=#ffcccc>$limit_view</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>x@</b></font></td>
<td bgcolor=#ffffff>
EOF

foreach (split("\0",$GOODS{$directory}{'howto_pay'})) { print "$_ "; }

print <<"EOF";
</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b>S</b></font></td>
<td bgcolor=#ffffff>$GOODS{$directory}{'howto_carriage'}</td>
</tr>
<tr>
<td bgcolor=#ffeedd><b></b></font></td>
<td bgcolor=#ffffff>$GOODS{$directory}{'howto_forward'}</td>
</tr>
</table>
<p>
EOF

print "<table><tr>";
foreach (split("\0",$GOODS{$directory}{'attc'})) { print "<td><img src=\"image.cgi?dir=$directory&iname=$_\" alt=\"Yt摜$i\"></td>\n"; }
print "</tr></table>\n";
if ($GOODS{$directory}{'attc'}) { print "<p>\n"; }

print <<"EOF";
$VALUE<p>
<hr noshade>
EOF

if ($SU) { print "<p>&nbsp; Ȃ͂̃I[NV̎Ǘ҂ł.<p>\n"; }
elsif ($PASSWD) { print "<p>&nbsp; Ȃ͂̃I[NV̏oi҂ł.<p>\n"; }

print <<"EOF";
<table width=100%>
<tr bgcolor=#ffeedd>
<td>

EOF

if ($remain <= 0) {

print <<"EOF";
<table border=$border cellpadding=1 cellspacing=2 width=100%>
<tr>
<td bgcolor=#888888><font color=#ffffff size=+1>@ D I @</font></td>
</tr></table>
EOF

}

if ($PASSWD) {

	$view_handle = "<th bgcolor=#555555 align=right><font color=#ffffff size=+1>D</font></th>\n";
	$result = "<th bgcolor=#555555 align=right><font color=#ffffff size=+1>d[</font></th>\n";
	$result .= "<th bgcolor=#555555 align=right><font color=#ffffff size=+1>dbԍ</font></th>\n";
	$result .= "<th bgcolor=#555555 align=right><font color=#ffffff size=+1>FAXԍ</font></th>\n";
}

print <<"EOF";
<table border=$border cellpadding=1 cellspacing=2 width=100%>
<tr>
<th bgcolor=#555555 align=right><font color=#ffffff size=+1>Dԍ</font></th>
$view_handle$result<th bgcolor=#555555 align=right><font color=#ffffff size=+1>Di</font></th>
<th bgcolor=#555555 align=right><font color=#ffffff size=+1>D</font></th>
</tr>
EOF

if ($none) {

	if ($PASSWD) { $colspan = 7; }
	else { $colspan = 4; }

	print <<"EOF";
<tr>
<td colspan=$colspan bgcolor=#ffffff align=left>DȂ</td>
</tr>
EOF

}
else {
	if (!-e "$base_dir$directory\/stop.$data_ext") { $kekka = 0; }
	elsif (open(END,"$base_dir$directory\/stop.$data_ext")) {

		$rakusatsusha = <END>;
		close(END);

		if ($rakusatsusha ne "") {

			($number2_c,$tend_c,$handle_c,$email_c,$tel_c,$fax_c,$date_c,$host_c) = &DecodeCSV($rakusatsusha);
			$kekka = 1;
		}
		else { $kekka = 0; }
	}
	else { $kekka = 0; }

	$i = 1;
	foreach (@TEND) {

		s/\n//g;
		($number2,$tend,$handle,$email,$tel,$fax,$date,$host) = &DecodeCSV($_);

		if ($i) {

			$bg = "#ffaaaa";
			$i = 0;
			$mes = 1;
			$b1 = "<font size=+1>";
			$b2 = "</font>";
			$tend_fee = $plus_fee2 + $tend;
			if ($kekka) { $j = "&lt;D&gt;"; }

			if ($PASSWD && $number2 eq $number2_c) {

				$result3 = "<p> D҂Sł悤Ał邾AƂĂ.<p>";
				$result2 = "<td bgcolor=$bg align=center><a href=\"mailto:$email?subject=\[$number\] $GOODS{$directory}{'goods_name'}\">$email_c</a></td>\n";
				$result2 .= "<td bgcolor=$bg align=center>$tel_c</td>\n";
				$result2 .= "<td bgcolor=$bg align=center>$fax_c</td>\n";
			}
			elsif ($PASSWD && $remain > 0) { $result2 = "<td bgcolor=$bg align=center colspan=3>DɊJ</td>\n"; }
			elsif ($PASSWD && $number2 ne $number2_c) { $result2 = "<td bgcolor=$bg align=center>ERROR(031)</td>\n"; }
			else { $result2 = ""; }
		}
		else {
			$bg = "#ffffff"; $b1 = $b2 = $j = "";
			if ($PASSWD) { $result2 = "<td bgcolor=$bg align=right>&nbsp;</td>\n<td bgcolor=$bg align=right>&nbsp;</td>\n<td bgcolor=$bg align=right>&nbsp;</td>\n"; }
		}

		1 while $tend =~ s/(.*\d)(\d\d\d)/$1,$2/g;

		if ($PASSWD) { $view_handle = "<td bgcolor=$bg align=right>$b1$handle$b2</td>\n"; }

		print <<"EOF";
<tr>
<td bgcolor=$bg align=right>$b1$j $number2$b2</td>
$view_handle$result2<td bgcolor=$bg align=right>$b1$tend$b2 ~</td>
<td bgcolor=$bg align=right>$b1$date$b2</td>
</tr>
EOF
	}
}

print <<"EOF";
</table></td></tr></table>
&nbsp;&nbsp;[<a href="tender.cgi?number=$number$ext&p=$in{'p'}">XV</a>]
<p>
EOF

print "$result3\n";

print <<"EOF";
<table border=$border cellpadding=1 cellspacing=2 width=100%>
<tr>
<td bgcolor=#888888><font color=#ffffff size=+1>@o i     (FAQ)@</font></td>
</tr></table>

<table width=100%>
<tr bgcolor=#ffeedd>
<td>
<br>
<blockquote>
$q_r
<form method=POST action="tender.cgi">
<input type=hidden name="number" value="$in{'number'}">
<input type=hidden name="p" value="$in{'p'}">
<input type=hidden name="action" value="faq">
EOF
	if (open(DATA,"$base_dir$directory\/faq.$data_ext")) {

		@FAQ = <DATA>;
		close(DATA);

		foreach (@FAQ) {

			s/\n//g; s/\r//g;
			($key,$val,$tim) = split(/\t/,$_,3);

			if ($key =~ /^Q(\d+)/) {

				$i = $1;
				$QUESTION{$i} .= "\0" if (defined($QUESTION{$i}));
				$QUESTION{$i} .= "$val\t$tim";
			}
			elsif ($key =~ /^A(\d+)/) {

				$i = $1;
				$ANSWER{$i} .= "\0" if (defined($ANSWER{$i}));
				$ANSWER{$i} .= "$val\t$tim";
			}
		}

		$i = 1;

		foreach $key (sort keys %QUESTION) {

			($val,$tim) = split(/\t/,$QUESTION{$key},2);

			if ($PASSWD && !$SU) {

				print "<b>p\. $val</b> <font size=-1>($tim)</font><br>\n";

				if ($ANSWER{$key}) {

					foreach $val (split("\0",$ANSWER{$key})) {

						($val,$tim) = split(/\t/,$val,2);
						print "`&gt; $val <font size=-1>($tim)</font><br>\n";
					}
					print "ǋL <input type=text name=\"A$key\" size=70><p>\n"; $button = 1;
				}
				else { print " <input type=text name=\"A$key\" size=70><p>\n"; $button = 1; }

				$i++;
			}
			elsif ($PASSWD && $SU) {

				print "<b>p\. $val</b> <font size=-1>($tim)</font><br>\n";

				if ($ANSWER{$key}) {

					foreach $val (split("\0",$ANSWER{$key})) {

						($val,$tim) = split(/\t/,$val,2);
						print "`&gt; $val <font size=-1>($tim)</font><br>\n";
					}
				}
				else { print "<p>\n"; }

				$i++;
			}
			elsif ($ANSWER{$key} ne "") {

				print "<b>p\. $val</b> <font size=-1>($tim)</font><br>\n";

				foreach $val (split("\0",$ANSWER{$key})) {

					($val,$tim) = split(/\t/,$val,2);
					print "`&gt; $val <font size=-1>($tim)</font><br>\n";
				}
				print "<p>\n";

				$i++;
			}
		}

		if ($i > 1) { print "<hr size=1>\n"; }
	}

	$now = time;

	if (!$PASSWD || $SU) { print "<p>V <input type=text name=\"Q$now\" size=70><p>\n"; $button = 1; }
	if ($button) { print "<input type=submit value=\"   M  \" onClick=\"message(); return f\"> <input type=reset value=\"  ~   \"><p>\n"; }

	print <<"EOF";
<font size=-1>
 oi҂񓚂ď߂āAɎ̉񓚂fڂ܂B<br>
 l񓙂ꂽɑ΂ẮAoi҂͉񓚂Ȃ悤ӂB<br>
 񓚂Ă҂ɂ͓dq[܂̂ŁAfڂB
</font>

</blockquote>
</td></tr></table>
</form>
EOF

if ($remain > 0) {

	$tend_fee2 = $tend_fee;
	1 while $tend_fee2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;

	if ($tend_fee != $max_fee2) {

		if (!$mes) { $mes = "DJn͍ŒᗎDiƂȂ܂B"; }
		else { $mes = "DPʐɂA̋zȊO̓D͂ł܂B"; }
	}

	print <<"EOF";
<form method=POST action="tender.cgi" name="form1">
<input type=hidden name="action" value="regist">
<input type=hidden name="p" value="$in{'p'}">
<input type=hidden name="number" value="$in{'number'}">

<table border=$border cellpadding=1 cellspacing=2 width=100%>
<tr>
<td bgcolor=#888888><font color=#ffffff size=+1>@@D@</font></td>
</tr></table>

<table width=100%>
<tr bgcolor=#ffeedd>
<td>

<blockquote>

<br>

<b>jbNl[</b><br>
D҂ł邠Ȃ̖OłBDɂ͕\\܂B<p>
<blockquote><input type=text name="handle2" value="$COOKIE{'handle2'}" size=20></blockquote>
<p>

<b>Di</b><br>
zmF̏A`FbNĂB$mes
EOF
	if ($max_fee2 == $GOODS{$directory}{'min_fee'}) { print "<b>̏oi͍ŒᗎDiƊ]Dizɐݒ肳Ă܂̂ŁA̋zI΂ȂD҂ƂȂÃI[NV͏I܂B</b>\n"; }
	elsif ($max_fee) { print "<b>̏oiɂ͊]Di $max_feeɐݒ肳Ă܂̂ŁA̋zI΂ȂD҂ƂȂÃI[NV͏I܂B</b>\n"; }

	print <<"EOF";
<p>
<blockquote>
EOF

	if ($tend_fee != $max_fee2) {

		if ($tend_fee < $max_fee2 || $max_fee2 == 0) { print "<input type=radio name=\"tend2\" value=\"$tend_fee\" size=10> $tend_fee2 ~ (D)<br>\n"; }
		elsif ($tend_fee >= $max_fee2) { $mes2 = "ŏIi/"; }
	}

	if ($max_fee) { print "<input type=radio name=\"tend2\" value=\"$max_fee2\" size=10> $max_fee ($mes2]Diő)\n"; }

	print <<"EOF";
</blockquote>
<p>

<b>d[</b><br>
Dꍇɏoi҂ƘAdvȃAhXłB
ׂĔpŁAd[AhXP<b>m</b>LB
d[AhXȊO͓͂̕ȂłB
<p>
<blockquote><input type=text name="email2" value="$COOKIE{'email2'}" size=40> <font size=-1>(pŐ)</font></blockquote>
<p>

<b>d[ȊO̘A</b><br>
d[L~XŘAȂꍇ̎iƂāAdbԍƂe`wԍA܂͂̂ꂩLB
<p>
<blockquote>
dbԍ <input type=text name="tel2" value="$COOKIE{'tel2'}" size=40>  u 090-00000000 10] v<br>
e`wԍ <input type=text name="fax2" value="$COOKIE{'fax2'}" size=40>  u 03-1234-5678 v
</blockquote>
<p>
EOF

#<b>l</b><br>
#<blockquote><input type=text name="remarks2" value="$in{'remarks2'}" size=70></blockquote>
#<p>

if (!$PASSWD) { print "<input type=submit value=\"   pKɓӂēD  \"> <input type=reset value=\"  ~ Zbg  \" onClick=\"message(); return f\">\n"; }
else {print " oi҂ƂăANZXĂꍇ͓D{^͕\\܂.\n"; }

	print <<"EOF";
</blockquote>
</td></tr></table>
</form>
<h3>spKt</h3>
<form><textarea cols=80 rows=10>
EOF

	foreach (@KITEI) { print; }

	print "\n"; #폜Ȃ.
	print 'QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ' . "\n";
	print "t[}[PbgEVXe http://www.rescue.ne.jp/\n";
	print "</textarea></form><p>\n";
}

if ($PASSWD && $remain > 0) {

	print <<"EOF";
<form method=POST action="tender.cgi">
<input type=hidden name="action" value="notend">
<input type=hidden name="number" value="$in{'number'}">
<input type=hidden name="p" value="$in{'p'}">
<input type=hidden name="select" value="delete">
<table border=0 sellpadding=2 sellspacing=3>
<tr><th bgcolor=#555555 align=center><font color=#ffffff size=+1>  D   </font></th></tr>
<tr><td bgcolor=#555555 align=center><input type=submit value=" o i   " onClick="message(); return f"></td></tr>
</table>
</form>
EOF
}
else {
	$now = time;

	if ($PASSWD && !@TEND) {

		print <<"EOF";
<form method=POST action="tender.cgi">
<input type=hidden name="action" value="notend">
<input type=hidden name="number" value="$in{'number'}">
<input type=hidden name="p" value="$in{'p'}">
<input type=hidden name="select" value="delete">
<table border=0 sellpadding=2 sellspacing=3>
<tr><th bgcolor=#555555 align=center><font color=#ffffff size=+1>  D   </font></th></tr>
<tr><td bgcolor=#ffeedd align=center><input type=submit value=" o i   " onClick="message(); return f"></td></tr>
</form>
EOF
		if ($number + 604800 > $now) { # ďoi͂PT(604800b)ȓ

			print <<"EOF";
<form method=POST action="tender.cgi">
<input type=hidden name="action" value="notend">
<input type=hidden name="number" value="$in{'number'}">
<input type=hidden name="p" value="$in{'p'}">
<input type=hidden name="select" value="repost">
<tr><td bgcolor=#ffeedd align=center><input type=submit value="  x o i " onClick="message(); return f"></td></tr>
</table>
</form>
EOF
		}
		else { print "</table>\n<p> ܂łɓDȂIꍇɁA{^PŊȒPďoił̂́AIPTԈȓł.\n"; }
	}
}

if (!$PASSWD) {

	print <<"EOF";
<form method=POST action="tender.cgi">
<input type=hidden name="action" value="redirect">
<input type=hidden name="number" value="$in{'number'}">
<table border=0 sellpadding=2 sellspacing=3>
<tr><th bgcolor=#555555 align=center><font color=#ffffff size=+1>  D   </font></th></tr>
<tr><th bgcolor=#ffeedd align=center><input type=password name="p" value="" size=20></th></tr>
<tr><td bgcolor=#555555 align=center><input type=submit value="   s  "></td></tr>
</table>
</form>
EOF
}

print <<"EOF";
<h3><hr size=2 noshade>
[<a href="tender.cgi?number=$number$ext&p=$in{'p'}">XV</a>]
EOF

if ($PASSWD) { print "[<a href=\"tender.cgi?number=$number$ext\">ʎ҂Ƃĉʂ</a>]\n"; }
if ($PASSWD && $SU) { print "[<a href=\"tender.cgi?number=$number$ext&p=$GOODS{$directory}{'passwd'}\">oi҂Ƃĉʂ</a>]\n"; }

print <<"EOF";
[<a href="auction.cgi">I[NVꗗ</a>]
<hr size=2 noshade></h3>
</body>
</html>
EOF

exit;

}

sub regist {

if ($TEND[0] ne "") { ($number2,$max_tend,$handle,$email,$tel,$fax,$date,$host) = &DecodeCSV($TEND[0]); }
if ($max_tend == 0) { $max_tend = $GOODS{$directory}{'min_fee'}; $max_tend =~ s/\,//g; }

$date_num = sprintf("%04d%02d%02d%02d%02d%02d",$year +1900,$mon +1,$mday,$hour,$min,$sec);

if ($in{'handle2'} eq '') { &error2("̓~X܂","jbNl[LĂ."); }

$min_fee2 = $GOODS{$directory}{'min_fee'};
1 while $min_fee2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;

$plus_fee = &plus_fee($GOODS{$directory}{'min_fee'});
$tend_fee = $tend_fee2 = $plus_fee + $max_tend;
1 while $tend_fee2 =~ s/(.*\d)(\d\d\d)/$1,$2/g;
$in{'tend2'} =~ s/\,//g;
if ($in{'tend2'} == 0 || $in{'tend2'} =~ /\D/) { &error2("̓~X܂","DimF̏A`FbNĂ."); }

if ($in{'tend2'} == $GOODS{$directory}{'max_fee'} || $in{'tend2'} == $tend_fee) { ; }
else {
	if ($TEND[0] eq "" && $in{'tend2'} == $GOODS{$directory}{'min_fee'}) { ; }
	elsif ($GOODS{$directory}{'max_fee'} && $TEND[0] eq "") { &error2("̓~X܂","DɂȂ܂̂ŁAŒᗎDił $min_fee2 ~܂͊]Dîꂩ̋zIĂ.","DsOɑ̕DĂ\\܂̂ŁAʂ߂XVĂ݂Ă."); }
	elsif (!$GOODS{$directory}{'max_fee'} && $TEND[0] eq "") { &error2("̓~X܂","DɂȂ܂̂ŁAŒᗎDił $min_fee2 ~IĂ.","DsOɑ̕DĂ\\܂̂ŁAʂ߂XVĂ݂Ă."); }
	elsif ($GOODS{$directory}{'max_fee'}) { &error2("̓~X܂","DPʂł̓DɂȂ܂̂ŁA$tend_fee2 ~܂͊]Dîꂩ̋zIĂ.","DsOɑ̕DĂ\\܂̂ŁAʂ߂XVĂ݂Ă."); }
	else { &error2("̓~X܂","DPʂł̓DɂȂ܂̂ŁA$tend_fee2 ~IĂ.","DsOɑ̕DĂ\\܂̂ŁAʂ߂XVĂ݂Ă."); }
}

if ($in{'email2'} !~ /\b[-\w.]+@[-\w.]+\.[-\w]+\b/) { &error2("̓~X܂","d[𔼊pŐLqĂ."); }
if ($in{'tel2'} eq '' && $in{'fax2'} eq '') { &error2("̓~X܂","dbԍ܂͂e`wԍAiƂďȂƂꂩ͂L."); }

$COOKIE{'handle2'} = $in{'handle2'};
$COOKIE{'email2'} = $in{'email2'};
$COOKIE{'tel2'} = $in{'tel2'};
$COOKIE{'fax2'} = $in{'fax2'};

push(@EDIT,$date_num);
push(@EDIT,$in{'tend2'});
push(@EDIT,$in{'handle2'});
push(@EDIT,$in{'email2'});
push(@EDIT,$in{'tel2'});
push(@EDIT,$in{'fax2'});
push(@EDIT,$date_now);
push(@EDIT,$HOST);

if (-e "$base_dir$directory\/stop.$data_ext") {

	if ($ext == 1) { &error("G[","̏oi͓DłȂԂɂȂĂ܂(023)"); }
	$ext = 0; &error("D؂ɂȂ܂","<a href=\"tender.cgi?number=$number$ext&p=$in{'p'}\">D</a>");
}

if (!open(DATA,">> $base_dir$directory\/tender.$data_ext")) { &error("VXeG[(024)",$!); }
print DATA &EncodeCSV(@EDIT) . "\n";
close(DATA);

chmod(0666,"$base_dir$directory\/tender.$data_ext");

#]DiɂDI
if ($GOODS{$directory}{'max_fee'} != 0 && $GOODS{$directory}{'max_fee'} <= $in{'tend2'}) {

	$in{'tend2'} = $GOODS{$directory}{'max_fee'};

	if (!rename("$base_dir$directory","$base_dir$number\.0")) { &error("VXeG[(025)","̏oi͓D؂ɂȂ܂ADł܂ł.","$numberG[ł邱ƂǗ҂ɂA."); }
	$ext = 0;

	if (!-e "$base_dir$number\.0\/stop.$data_ext") {

		if (!open(END,"> $base_dir$number\.0\/stop.$data_ext")) { &error("VXeG[(026)","DIɎs܂."); }
		print END &EncodeCSV(@EDIT) . "\n";
		close(END);

		&end_info($number,$GOODS{$directory}{'handle'},$GOODS{$directory}{'email'},$GOODS{$directory}{'goods_name'},$GOODS{$directory}{'passwd'},1);
		&end_info2($number,$date_num,$in{'handle2'},$in{'email2'},$GOODS{$directory}{'goods_name'},$GOODS{$directory}{'remarks'});
	}

	&error("̏oi͗D܂","<a href=\"tender.cgi?number=$number$ext&p=$in{'p'}\">D</a>");
}

if (open(DATA,"$base_dir$directory\/tender.$data_ext")) {

	@TEND = <DATA>;
	close(DATA);
	@TEND = reverse @TEND;
}

$none = 0;

($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg) = gmtime(time + 30*24*60*60);
$y0="Sunday"; $y1="Monday"; $y2="Tuesday"; $y3="Wednesday"; $y4="Thursday"; $y5="Friday"; $y6="Saturday";
$m0="Jan"; $m1="Feb"; $m2="Mar"; $m3="Apr"; $m4="May"; $m5="Jun"; $m6="Jul"; $m7="Aug"; $m8="Sep"; $m9="Oct"; $m10="Nov"; $m11="Dec";
@youbi = ($y0,$y1,$y2,$y3,$y4,$y5,$y6);
@monthg = ($m0,$m1,$m2,$m3,$m4,$m5,$m6,$m7,$m8,$m9,$m10,$m11);
$date_gmt = sprintf("%s\, %02d\-%s\-%04d %02d:%02d:%02d GMT",$youbi[$wdayg],$mdayg,$monthg[$mong],$yearg +1900,$hourg,$ming,$secg);

print "Set-Cookie: $ENV{'SCRIPT_NAME'}=number2:$date_num\,handle2:$COOKIE{'handle2'}\,email2:$COOKIE{'email2'}\,tel2:$COOKIE{'tel2'}\,fax2:$COOKIE{'fax2'}; expires=$date_gmt\n";

}

sub faq {

	while(($key,$val) = each %in) {

		if ($val eq "") { next; }

		if ($key =~ /^Q(\d+)$/) { push(@QA,"$key\t$val\t$date_faq"); $q_r = " ḾAoi҂̉񓚂ƕ\\܂B<p>"; &faq_mail($number,$GOODS{$directory}{'handle'},$GOODS{$directory}{'email'},$GOODS{$directory}{'goods_name'},$val,$GOODS{$directory}{'passwd'},$ext); last; }
		elsif ($key =~ /^A(\d+)$/ && $PASSWD) { push(@QA,"$key\t$val\t$date_faq"); }
	}

	if (@QA) {

		$log = "$base_dir$directory\/" . "faq.$data_ext";

		if (!open(DATA,">> $log")) { &error("VXeG[(032)","FAQpOɋL^ł܂",$log); }
		foreach (@QA) { print DATA "$_\n"; }
		close(DATA);
		chmod(0666,"$base_dir$log");
	}
}

sub faq_mail {

	# ⓞ[(oi҈)

	local($number,$uname,$send_to,$goods_name,$question,$p,$flug) = @_;
	$question =~ s/\r/\n/g;

	if ($hiho) {

		$SUBJECT = "\[$number\] Auction";
		if (!open(OUT,"| $sendmail -s \"$SUBJECT\" -f \"$mailto\" $send_to")) { &error("VXeG[","[ł܂ł"); }
	}
	else {
		if (!open(OUT,"| $sendmail -t")) { &error("VXeG[","[ł܂ł"); }

		print OUT &jis("X-Processed: $date_now\n");
		print OUT "X-HOST: $HOST\n";
		print OUT "X-Mailer: PERSONAL AUCTION SYSTEM by www.rescue.ne.jp\n";
		print OUT "X-HTTP-REFERER: $ENV{'HTTP_REFERER'}\n";
		print OUT "To: $send_to\n";
		print OUT "From: $mailto\n";
		print OUT &jis("Subject: \[$number\] oi҂ւ̎\n");
		print OUT "\n";
	}

	print OUT &jis("$unamel\n\n");

	print OUT &jis("oiԍ $number\n");
	print OUT &jis("oii $goods_name\n\n");

	print OUT &jis("L̏oiɊւĎ₪͂܂B\n\n");

	print OUT "-----------------------------------------------------------------\n";
	print OUT &jis($question);
	print OUT "\n-----------------------------------------------------------------\n\n";

	print OUT &jis("񓚂ɂ͓Dʂ֏oi҂ƂăANZXĂB\n");
	print OUT &jis("񓚂ȂƎ\\܂B\\ƕsK؂ȓe܂\n");
	print OUT &jis("̏ꍇ͉񓚂ȂłBȂÃ[ɕԐMĂ\n");
	print OUT &jis("҂ɂ͔zB܂̂łӂB\n\n");

	print OUT $base_url . "tender.cgi?number=$number" . "$flug&p=$p\n";

	print OUT "\n";
	print OUT &jis($sign);
	close(OUT);
}

sub delete {

&delete_all("$base_dir$directory");
if (!rmdir("$base_dir$directory")) { &error("VXeG[(027)","f[^폜ł܂($!)"); }

$log = "$log_dir" . "delete.$data_ext";

if (!open(DATA,">> $log")) { &error("VXeG[(030)","oi폜pOɋL^ł܂"); }
print DATA "DELETE $directory -- $date_now\n";
print DATA "ڑzXg $HOST\n";
print DATA "uEU $HTTP_USER_AGENT\n";
print DATA "\n";
close(DATA);
chmod(0666,"$base_dir$log");

print "Content-type: text/html\n\n";
print <<"EOF";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<HTML>
<HEAD>
<TITLE>$title_bar</TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
</HEAD>
$body
<h1>oiԍ $number 폜܂</h1>
<h3><hr size=2 noshade>
[<a href="auction.cgi">I[NVꗗ</a>]
<hr size=2 noshade></h3>
</body></html>
EOF

exit;

}

sub repost {

$limit = time + ($GOODS{$directory}{'time'} * 86400);

if (!rename("$base_dir$directory","$base_dir$limit\.1")) { &error("VXeG[(028)","ďoił܂($!)"); }

$GOODS{$directory}{'start'} = $date_now;

if (open(DATA,"> $base_dir$limit\.1\/index.$data_ext")) {

	while (($key,$val) = each %{ $GOODS{$directory} }) { foreach (split("\0",$val)) { print DATA "$key\t$_\n"; } } #2002/03/18
	close(DATA);
}

unlink("$base_dir$limit\.1\/stop.$data_ext");
rename("$base_dir$limit\.1\/tender.$data_ext","$base_dir$limit\.1\/tender.$data_ext\.bak");

$log = "$log_dir" . "regist.$data_ext";

if (!open(DATA,">> $log")) { &error("VXeG[(017)","oio^pOɋL^ł܂"); }
print DATA "RE-POST $number -> $limit -- $date_now\n";
print DATA "ڑzXg $HOST\n";
print DATA "uEU $HTTP_USER_AGENT\n";
print DATA "\n";
close(DATA);
chmod(0666,"$base_dir$log");

print "Content-type: text/html\n\n";
print <<"EOF";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<HTML>
<HEAD>
<TITLE>$title_bar</TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
</HEAD>
$body
<h1>ďoi܂</h1>
<ul>
<li>I[NVԍ(₢킹ԍ)́A$number  <font size=+1>$limit</font> ɕύXƂȂ܂B
<li>̑̏oif[^͈ڍs܂BpX[hOƓlłB
</ul>

<h3><hr size=2 noshade>
[<a href="auction.cgi">I[NVꗗ</a>]
<hr size=2 noshade></h3>
</body></html>
EOF

exit;

}

sub error2 {

	local (@msg) = @_;
	local ($i);

	print "Content-type: text/html\n\n";

	print <<"EOF";
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
	<HTML>
	<HEAD>
	<TITLE></TITLE>
	<meta http-equiv="Content-Type" content="text/html; charset=x-sjis">
	<SCRIPT language="JavaScript">
	<!--
	function PageBack(){ history.back(); }
	//-->
	</SCRIPT>
	</HEAD>
	$body
	<table width=100%>
	<tr>
	<td bgcolor=#ffe566 colspan=2><font size=+2><b>$_[0]</b></font></td>
	</tr>
	</table>
	<p>
EOF
	print "<ul>\n";
	foreach $i (1 .. $#msg) { print "<li>$msg[$i]\n"; }
	print "</ul>\n";

	print <<"EOF";
	<h3>[<A HREF="JavaScript:history.back()">Ỏʂ</A>] [<A HREF="tender.cgi?number=$number$ext&p=$in{'p'}"></A>] [<A HREF="auction.cgi">ŏ̉ʂ</A>]</h3>
	</body></html>
EOF
	exit;
}
